#!/usr/bin/env python

# Base on Conbagui tutorial found here: http://fav.me/dapu76s

# It Creates a plastic like with neon center text
# author: Pocholo
# date: 9/24/2020

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder


# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>. 

from gimpfu import *

def pm_neon_lighted_frame_v2(roundframe, recframe, squareframe, backpattern, color):

	#Initiates the temporary state
	pdb.gimp_context_push()
	
	#Variables
	width = 1600
	height = 1200
	
	if roundframe:
		#Create the background
		img = pdb.gimp_image_new(width, height, RGB_IMAGE)
		backLayer = pdb.gimp_layer_new(img, width, height, RGB, "Dark wooden wall", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, backLayer, 0)
		pdb.gimp_layer_add_alpha(backLayer)
		pdb.gimp_context_set_pattern(backpattern)
		pdb.gimp_edit_bucket_fill(backLayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
			
		#Create the dark	
		darkLayer = pdb.gimp_layer_new(img, width, height, RGB, "Gradient", 95, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_add_layer(img, darkLayer, 0)
		pdb.gimp_layer_add_alpha(darkLayer)
		pdb.gimp_drawable_fill(darkLayer, FILL_TRANSPARENT)
		pdb.gimp_context_set_foreground((0, 0, 0))
		pdb.gimp_context_set_gradient_fg_transparent()
		pdb.gimp_context_set_gradient_reverse(TRUE)	
		pdb.gimp_drawable_edit_gradient_fill(darkLayer, GRADIENT_RADIAL, 0, TRUE, 3, 0.20, TRUE, 800, 600, 1350, 600)
		pdb.plug_in_gauss(img, darkLayer, 200, 200, 0)
		backLayer = pdb.gimp_image_merge_down(img, darkLayer, CLIP_TO_IMAGE)
	
		#View process	
		pdb.gimp_display_new(img)
		
		#Create the circular shape 1
		layer1 = pdb.gimp_layer_new(img, width, height, RGB, "Circle #1", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, layer1, 0)
		pdb.gimp_layer_add_alpha(layer1)
		pdb.gimp_drawable_fill(layer1, FILL_TRANSPARENT)
		pdb.gimp_image_select_ellipse(img, 2, 425, 225, 750, 750)
		pdb.plug_in_sel2path(img, layer1)
		pdb.gimp_selection_none(img)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_line_cap_style(CAP_ROUND)
		pdb.gimp_context_set_line_join_style(JOIN_MITER)
		pdb.gimp_context_set_line_miter_limit(10)
		pdb.gimp_context_set_line_width(10)
		pdb.gimp_context_set_stroke_method(STROKE_LINE)
		vector1 = pdb.gimp_image_get_active_vectors(img)
		pdb.gimp_edit_stroke_vectors(layer1, vector1)
	
		#Outer Glow
		pdb.python_layerfx_outer_glow(img, layer1, 
								  (255, 255, 255),	#color 
											   45,   #opacity
												0,   #contou
												0,   #noise
												4,   #mode - screen
												0,   #spread 
											   25,   #size 
											 TRUE,   #knockout 
											FALSE)   #merge	
				
		
		#Create the circular shape 2
		layer2 = pdb.gimp_layer_new(img, width, height, RGB, "Circle #2", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, layer2, 0)
		pdb.gimp_layer_add_alpha(layer2)
		pdb.gimp_drawable_fill(layer2, FILL_TRANSPARENT)
		pdb.gimp_image_select_ellipse(img, 2, 400, 240, 800, 720)
		pdb.plug_in_sel2path(img, layer2)
		pdb.gimp_selection_none(img)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_line_cap_style(CAP_ROUND)
		pdb.gimp_context_set_line_join_style(JOIN_MITER)
		pdb.gimp_context_set_line_miter_limit(10)
		pdb.gimp_context_set_line_width(10)
		pdb.gimp_context_set_stroke_method(STROKE_LINE)
		vector2 = pdb.gimp_image_get_active_vectors(img)
		pdb.gimp_edit_stroke_vectors(layer2, vector2)
	
		#Outer Glow
		pdb.python_layerfx_outer_glow(img, layer2, 
								  (255, 255, 255),	#color 
											   45,   #opacity
												0,   #contou
												0,   #noise
												4,   #mode - screen
												0,   #spread 
											   25,   #size 
											 TRUE,   #knockout 
											FALSE)   #merge	
				
		#Create the circular shape 3
		non_empty = pdb.gimp_edit_copy(layer2)
		layer3 = pdb.gimp_layer_new(img, width, height, RGB, "Circle #3", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, layer3, 0)
		pdb.gimp_layer_add_alpha(layer3)
		pdb.gimp_drawable_fill(layer3, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(layer3, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
		layer3 = pdb.gimp_item_transform_rotate(layer3, 45.00, TRUE, 800.00, 600.00)
		pdb.gimp_layer_resize_to_image_size(layer3)
	
		#Create the circular shape 4	
		non_empty = pdb.gimp_edit_copy(layer3)
		layer4 = pdb.gimp_layer_new(img, width, height, RGB, "Circle #4", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, layer4, 0)
		pdb.gimp_layer_add_alpha(layer4)
		pdb.gimp_drawable_fill(layer4, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(layer4, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)
		layer4 = pdb.gimp_item_transform_flip_simple(layer4, ORIENTATION_HORIZONTAL, TRUE, 0)
				
		#Create the circular shape 5	
		layer5 = pdb.gimp_layer_new(img, width, height, RGB, "Circle #5", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, layer5, 0)
		pdb.gimp_layer_add_alpha(layer5)
		pdb.gimp_drawable_fill(layer5, FILL_TRANSPARENT)
		pdb.gimp_image_select_ellipse(img, 2, 400, 200, 800, 800)
		pdb.plug_in_sel2path(img, layer5)
		pdb.gimp_selection_none(img)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_line_cap_style(CAP_ROUND)
		pdb.gimp_context_set_line_join_style(JOIN_MITER)
		pdb.gimp_context_set_line_miter_limit(10)
		pdb.gimp_context_set_line_width(10)
		pdb.gimp_context_set_stroke_method(STROKE_LINE)
		vector5 = pdb.gimp_image_get_active_vectors(img)
		pdb.gimp_edit_stroke_vectors(layer5, vector5)
	
		#Outer Glow
		pdb.python_layerfx_outer_glow(img, layer5, 
								  (255, 255, 255),	#color 
											   45,   #opacity
												0,   #contou
												0,   #noise
												4,   #mode - screen
												0,   #spread 
											   25,   #size 
											 TRUE,   #knockout 
											FALSE)   #merge	
			
		#Create the lights
		lightlayer = pdb.gimp_layer_new(img, width, height, RGB, "Lights", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, lightlayer, 0)
		pdb.gimp_layer_add_alpha(lightlayer)
		pdb.gimp_drawable_fill(lightlayer, FILL_TRANSPARENT)
		pdb.gimp_context_set_brush("Sparkle")
		pdb.gimp_context_set_brush_size(250)
		pdb.gimp_context_set_brush_hardness(0.01)
		pdb.gimp_context_set_brush_spacing(1.12)
		pdb.gimp_context_set_brush_force(0.50)
		pdb.gimp_context_set_paint_method("gimp-paintbrush")
		pdb.gimp_context_set_stroke_method(STROKE_PAINT_METHOD)
		vectors = pdb.gimp_image_get_active_vectors(img)
		pdb.gimp_edit_stroke_vectors(lightlayer, vectors)
	
		#Colorize
		colorlayer = pdb.gimp_layer_new(img, width, height, RGB, "Color", 90, LAYER_MODE_SOFTLIGHT)
		pdb.gimp_image_add_layer(img, colorlayer, 0)
		pdb.gimp_layer_add_alpha(colorlayer)
		pdb.gimp_context_set_foreground(color)
		pdb.gimp_drawable_fill(colorlayer, FILL_FOREGROUND)
	pdb.gimp_context_pop()			
	
	
	if recframe:
		#Create the background
		img = pdb.gimp_image_new(width, height, RGB_IMAGE)
		backLayer = pdb.gimp_layer_new(img, width, height, RGB, "Dark wooden wall", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, backLayer, 0)
		pdb.gimp_layer_add_alpha(backLayer)
		pdb.gimp_context_set_pattern(backpattern)
		pdb.gimp_edit_bucket_fill(backLayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
		
		#Create the dark	
		darkLayer = pdb.gimp_layer_new(img, width, height, RGB, "Gradient", 95, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_add_layer(img, darkLayer, 0)
		pdb.gimp_layer_add_alpha(darkLayer)
		pdb.gimp_drawable_fill(darkLayer, FILL_TRANSPARENT)
		pdb.gimp_context_set_foreground((0, 0, 0))
		pdb.gimp_context_set_gradient_fg_transparent()
		pdb.gimp_context_set_gradient_reverse(TRUE)	
		pdb.gimp_drawable_edit_gradient_fill(darkLayer, GRADIENT_SQUARE, 0, TRUE, 3, 0.20, TRUE, 800, 600, 1280, 600)
		pdb.plug_in_gauss(img, darkLayer, 500, 0, 0)
		backLayer = pdb.gimp_image_merge_down(img, darkLayer, CLIP_TO_IMAGE)
		
		#View process	
		pdb.gimp_display_new(img)
		
		#Create the rectangle shape 1
		layer1 = pdb.gimp_layer_new(img, width, height, RGB, "Frame #1", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, layer1, 0)
		pdb.gimp_layer_add_alpha(layer1)
		pdb.gimp_drawable_fill(layer1, FILL_TRANSPARENT)
		pdb.gimp_image_select_round_rectangle(img, 2, 300, 300, 1000, 600, 15, 15)
		pdb.plug_in_sel2path(img, layer1)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_line_cap_style(CAP_ROUND)
		pdb.gimp_context_set_line_join_style(JOIN_MITER)
		pdb.gimp_context_set_line_miter_limit(10)
		pdb.gimp_context_set_line_width(51)
		pdb.gimp_context_set_stroke_method(STROKE_LINE)
		vector1 = pdb.gimp_image_get_active_vectors(img)
		pdb.gimp_edit_stroke_vectors(layer1, vector1)
		pdb.gimp_selection_none(img)
		
		#Outer Glow
		pdb.python_layerfx_outer_glow(img, layer1, 
								  (255, 255, 255),	#color 
											   45,   #opacity
												0,   #contou
												0,   #noise
												4,   #mode - screen
												0,   #spread 
											   25,   #size 
											 TRUE,   #knockout 
											FALSE)   #merge
		#Inner glow
		pdb.python_layerfx_inner_glow(img, layer1, 
								        (0, 0, 0),   #color
											   45,   #opacity
											    0,   #contou
											    0,   #noise
											    3,   #mode - multiply 
											    1,   #source
											    0,   #choke 
											   20,   #size 
										     TRUE)   #merge
		
		#Create the lights
		lightlayer1 = pdb.gimp_layer_new(img, width, height, RGB, "Lights", 100, LAYER_MODE_OVERLAY)
		pdb.gimp_image_add_layer(img, lightlayer1, 0)
		pdb.gimp_layer_add_alpha(lightlayer1)
		pdb.gimp_drawable_fill(lightlayer1, FILL_TRANSPARENT)		
		pdb.gimp_brushes_set_brush("2. Block 02")
		pdb.gimp_context_set_brush_size(300)
		pdb.gimp_context_set_brush_default_hardness()
		pdb.gimp_context_set_brush_spacing(0.01)
		pdb.gimp_context_set_brush_force(0.50)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_paintbrush_default(lightlayer1, 2, [600, 313])
		pdb.gimp_paintbrush_default(lightlayer1, 2, [1000, 313])
		pdb.gimp_paintbrush_default(lightlayer1, 2, [600, 888])
		pdb.gimp_paintbrush_default(lightlayer1, 2, [1000, 888])								
		pdb.gimp_context_set_brush_angle(90)											
		pdb.gimp_paintbrush_default(lightlayer1, 2,	[313, 600]) 
		pdb.gimp_paintbrush_default(lightlayer1, 2, [1287, 600])
		pdb.gimp_context_set_brush_angle(0)
		
		#Duplicate light
		non_empty = pdb.gimp_edit_copy(lightlayer1)
		lightlayer2 = pdb.gimp_layer_new(img, width, height, RGB, "Light #2", 100, LAYER_MODE_SOFTLIGHT)
		pdb.gimp_image_add_layer(img, lightlayer2, 0)
		pdb.gimp_layer_add_alpha(lightlayer2)
		pdb.gimp_drawable_fill(lightlayer2, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(lightlayer2, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)									
		pdb.plug_in_gauss(img, lightlayer2, 20, 20, 0)
		
		#Colorize
		colorlayer = pdb.gimp_layer_new(img, width, height, RGB, "Color", 100, LAYER_MODE_SOFTLIGHT)
		pdb.gimp_image_add_layer(img, colorlayer, 0)
		pdb.gimp_layer_add_alpha(colorlayer)
		pdb.gimp_context_set_foreground(color)
		pdb.gimp_drawable_fill(colorlayer, FILL_FOREGROUND)									
	    
	
	
	if squareframe:
		#Create the background
		img = pdb.gimp_image_new(width, height, RGB_IMAGE)
		backLayer = pdb.gimp_layer_new(img, width, height, RGB, "Dark wooden wall", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, backLayer, 0)
		pdb.gimp_layer_add_alpha(backLayer)
		pdb.gimp_context_set_pattern(backpattern)
		pdb.gimp_edit_bucket_fill(backLayer, BUCKET_FILL_PATTERN, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
		
		#Create the dark	
		darkLayer = pdb.gimp_layer_new(img, width, height, RGB, "Gradient", 95, LAYER_MODE_NORMAL_LEGACY)
		pdb.gimp_image_add_layer(img, darkLayer, 0)
		pdb.gimp_layer_add_alpha(darkLayer)
		pdb.gimp_drawable_fill(darkLayer, FILL_TRANSPARENT)
		pdb.gimp_context_set_foreground((0, 0, 0))
		pdb.gimp_context_set_gradient_fg_transparent()
		pdb.gimp_context_set_gradient_reverse(TRUE)	
		pdb.gimp_drawable_edit_gradient_fill(darkLayer, GRADIENT_SQUARE, 0, TRUE, 3, 0.20, TRUE, 800, 600, 1280, 600)
		pdb.plug_in_gauss(img, darkLayer, 500, 0, 0)
		backLayer = pdb.gimp_image_merge_down(img, darkLayer, CLIP_TO_IMAGE)
		
		#View process	
		pdb.gimp_display_new(img)
		
		#Create the rectangle shape 1
		layer1 = pdb.gimp_layer_new(img, width, height, RGB, "Frame #1", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, layer1, 0)
		pdb.gimp_layer_add_alpha(layer1)
		pdb.gimp_drawable_fill(layer1, FILL_TRANSPARENT)
		pdb.gimp_image_select_round_rectangle(img, 2, 300, 300, 1000, 600, 15, 15)
		pdb.plug_in_sel2path(img, layer1)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_context_set_antialias(TRUE)
		pdb.gimp_context_set_line_cap_style(CAP_ROUND)
		pdb.gimp_context_set_line_join_style(JOIN_MITER)
		pdb.gimp_context_set_line_miter_limit(10)
		pdb.gimp_context_set_line_width(51)
		pdb.gimp_context_set_stroke_method(STROKE_LINE)
		vector1 = pdb.gimp_image_get_active_vectors(img)
		pdb.gimp_edit_stroke_vectors(layer1, vector1)
		pdb.gimp_selection_none(img)
		
		#Outer Glow
		pdb.python_layerfx_outer_glow(img, layer1, 
								  (255, 255, 255),	#color 
											   45,   #opacity
												0,   #contou
												0,   #noise
												4,   #mode - screen
												0,   #spread 
											   25,   #size 
											 TRUE,   #knockout 
											FALSE)   #merge
		#Inner glow
		pdb.python_layerfx_inner_glow(img, layer1, 
								        (0, 0, 0),   #color
											   45,   #opacity
											    0,   #contou
											    0,   #noise
											    3,   #mode - multiply 
											    1,   #source
											    0,   #choke 
											   20,   #size 
										     TRUE)   #merge
		
		layer1 = pdb.gimp_image_get_active_layer(img)

		
		
		#Create the lights
		lightlayer1 = pdb.gimp_layer_new(img, width, height, RGB, "Lights", 100, LAYER_MODE_OVERLAY)
		pdb.gimp_image_add_layer(img, lightlayer1, 0)
		pdb.gimp_layer_add_alpha(lightlayer1)
		pdb.gimp_drawable_fill(lightlayer1, FILL_TRANSPARENT)
		pdb.gimp_context_set_brush("2. Block 02")
		name = pdb.gimp_context_get_brush()
		pdb.gimp_context_set_brush_size(300)
		pdb.gimp_context_set_brush_angle(0)
		pdb.gimp_context_set_brush_default_hardness()
		pdb.gimp_context_set_brush_spacing(0.01)
		pdb.gimp_context_set_brush_force(0.50)
		pdb.gimp_context_set_foreground((255, 255, 255))
		pdb.gimp_paintbrush_default(lightlayer1, 2, [600, 313])
		pdb.gimp_paintbrush_default(lightlayer1, 2, [1000, 313])
		pdb.gimp_paintbrush_default(lightlayer1, 2, [600, 888])
		pdb.gimp_paintbrush_default(lightlayer1, 2, [1000, 888])								
		pdb.gimp_context_set_brush_angle(90)											
		pdb.gimp_paintbrush_default(lightlayer1, 2,	[313, 600]) 
		pdb.gimp_paintbrush_default(lightlayer1, 2, [1287, 600])
		pdb.gimp_context_set_brush_angle(0)
		
		#Duplicate light
		non_empty = pdb.gimp_edit_copy(lightlayer1)
		lightlayer2 = pdb.gimp_layer_new(img, width, height, RGB, "Light #2", 100, LAYER_MODE_SOFTLIGHT)
		pdb.gimp_image_add_layer(img, lightlayer2, 0)
		pdb.gimp_layer_add_alpha(lightlayer2)
		pdb.gimp_drawable_fill(lightlayer2, FILL_TRANSPARENT)
		floating_sel = pdb.gimp_edit_paste(lightlayer2, FALSE)
		pdb.gimp_floating_sel_anchor(floating_sel)									
		pdb.plug_in_gauss(img, lightlayer2, 20, 20, 0)
		
		#Colorize
		colorlayer = pdb.gimp_layer_new(img, width, height, RGB, "Color", 100, LAYER_MODE_SOFTLIGHT)
		pdb.gimp_image_add_layer(img, colorlayer, 0)
		pdb.gimp_layer_add_alpha(colorlayer)
		pdb.gimp_context_set_foreground(color)
		pdb.gimp_drawable_fill(colorlayer, FILL_FOREGROUND)
		
				
		pdb.gimp_image_set_active_layer(img, layer1)
		pdb.gimp_item_set_lock_content(layer1, TRUE)								
		pdb.gimp_image_set_active_layer(img, lightlayer1)
		pdb.gimp_item_set_lock_content(lightlayer1, TRUE)									
		pdb.gimp_image_set_active_layer(img, lightlayer2)
		pdb.gimp_item_set_lock_content(lightlayer2, TRUE)									
		outerglow = pdb.gimp_image_get_layer_by_name(img, "Frame #1-outerglow")
		pdb.gimp_image_set_active_layer(img, outerglow)
		pdb.gimp_item_set_lock_content(outerglow, TRUE)	
		pdb.gimp_image_scale(img, 1200, 1200)
		pdb.gimp_image_set_active_layer(img, backLayer)
	pdb.gimp_context_set_defaults()
	pdb.gimp_context_set_default_colors()
	
	
register(
	"pm_neon_lighted_frame",
	"Creates a neon lighted frame",
	"Creates a neon lighted frame",
	"Pocholo",
	"Pocholo",
	"2020",
	"PM Neon lighted frame v2",
	"",
[	
	(PF_TOGGLE, "roundframe", "Round?", False),
	(PF_TOGGLE, "recframe", "Rectangle?", False),
	(PF_TOGGLE, "squareframe", "Square?", False),
	(PF_PATTERN, "backpattern", "Background pattern", "Bricks"),
	(PF_COLOR, "color", "Colorize", (0, 255, 255)),
	
],
[],
pm_neon_lighted_frame_v2, menu="<Image>/Pocholo-scripts/PM Neon lighted frame v2")
main()					